import {Component, OnInit} from '@angular/core';
import {pageSize} from '../../../app.constants';
import {ActivatedRoute, Router} from '@angular/router';
import {CommonService} from '../../../shared/common/common.service';
import {SystemService} from '../../../system/system.service';
import {OverAllService} from '../../overAll.service';
import {NzMessageService} from 'ng-zorro-antd';

@Component({
    selector: 'smart-trigger-list',
    templateUrl: './trigger-list.component.html',
    styles: []
})
export class TriggerListComponent implements OnInit {

    tempName;
    disName;
    discoveryids;

    pageNum = 1;
    pageCount = pageSize;
    totalNum;

    triggerList;

    selectList = [];
    allChecked;
    indeterminate;

    constructor(private overAllSer: OverAllService, private routerInfo: ActivatedRoute, private router: Router,
                private message: NzMessageService, private systemSer: SystemService,
                private commonSer: CommonService) {
        this.routerInfo.queryParams.subscribe(
            (res) => {
                this.discoveryids = res.id;
                this.tempName = res.name;
            }
        );
    }

    checkAll(value: boolean): void {
        this.triggerList.forEach(data => data.checked = value);
        this.refreshStatus();
    }

    currentPageDataChange($event: Array<{ checked: boolean }>): void {
        this.triggerList = $event;
    }

    selectItem(item, e) {
        if (e) {
            this.selectList.push(item);
        } else {
            this.selectList.forEach((value, index) => {
                if (value.id == item.id) {
                    this.selectList.splice(index, 1);
                }
            });
        }
        this.refreshStatus();
    }

    refreshStatus(): void {
        const allChecked = this.triggerList.every(value => value.checked === true);
        const allUnChecked = this.triggerList.every(value => !value.checked);
        this.allChecked = allChecked;
        this.indeterminate = (!allChecked) && (!allUnChecked);
    }

    ngOnInit() {
        this.getList();
    }

    getList() {
        const data = {
            pageNum: this.pageNum,
            pageCount: this.pageCount,
            hostIds: [this.discoveryids]
        };
        this.overAllSer.findItemPrototype(data).subscribe(
            (res) => {
                this.triggerList = res.data.data;
                this.totalNum = res.data.totalNum;
            }
        );
    }

    showAddModal() {

    }

}
